<template>
    <el-container style="height: 100%">
        <el-header>
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
                <!--左侧栏 和 header部分对于整个后台部分都是不变的，唯一变的就是上面3的部分，这里就通过router-view来展示所需控件-->
                <div v-if="!islogin" style="color:#909399;position:relative;top:35%;text-align:center">
                    您还没有登录，请先登录!
                </div>
                <div v-if="islogin" style="width:50%;position:relative;left:25%;top:10%;line-height: 42px;">
                    您的食品喜好有：
                    <br>
                    <el-tag
                    v-for="tag in foodtags"
                    :key="'food'+tag"
                    closable
                    :disable-transitions="false"
                    @close="foodHandleClose(tag)">
                    {{tag}}
                    </el-tag>
                    <el-input
                    class="input-new-tag"
                    v-if="foodInputVisible"
                    v-model="foodInputValue"
                    ref="saveTagInput"
                    size="small"
                    @keyup.enter.native="foodHandleInputConfirm"
                    @blur="foodHandleInputConfirm"
                    >
                    </el-input>
                    <el-button v-else class="button-new-tag" size="small" @click="foodShowInput">+ New Tag</el-button>
                    <br>
                    您的服务喜好有：
                    <br>
                    <el-tag
                        v-for="tag in sporttags"
                        :key="'sport'+tag"
                        closable
                        :disable-transitions="false"
                        @close="sportHandleClose(tag)">
                    {{tag}}
                    </el-tag>
                    <el-input
                    class="input-new-tag"
                    v-if="sportInputVisible"
                    v-model="sportInputValue"
                    ref="saveTagInput"
                    size="small"
                    @keyup.enter.native="sportHandleInputConfirm"
                    @blur="sportHandleInputConfirm"
                    >
                    </el-input>
                    <el-button v-else class="button-new-tag" size="small" @click="sportShowInput">+ New Tag</el-button>
                </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
import showViewInfoService from '@/services/showViewInfoService'
import changetags from '@/services/changetags'
export default {
  components: {
    commonaside,
    commonheader
  },
  data () {
    return {
      islogin: false,
      foodtags: [],
      foodInputVisible: false,
      foodInputValue: '',
      sporttags: [],
      sportInputVisible: false,
      sportInputValue: ''
    }
  },
  created () {
    this.getUserInfo()
    this.islogin = this.$store.state.token !== ''
  },
  methods: {
    async getUserInfo () {
      try {
        const response = await showViewInfoService.getInfo(
          {
            headers: {'Authorization': this.$store.state.token}
          })
        // console.log(response.data)
        this.foodtags = response.data.data.foodTypePrefer
        this.sporttags = response.data.data.serviceTypePrefer
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
        } else {
          this.error = error.response.data.error
        }
      }
    },
    async foodHandleClose (tag) {
      try {
        const response = await changetags.foodDelete({
          prefer: tag
        },
        {
          headers: {'Authorization': this.$store.state.token}
        })
        this.foodtags.splice(this.foodtags.indexOf(tag), 1)
        console.log(response)
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
          this.$alert('删除食品喜好标签失败！', '网络错误', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              // this.$router.push('/')
            }
          })
        } else {
          this.error = error.response.data.error
        }
      }
    },
    foodShowInput () {
      this.foodInputVisible = true
      this.$nextTick(_ => {
        this.$refs.saveTagInput.$refs.input.focus()
      })
    },
    async foodHandleInputConfirm () {
      try {
        let foodInputValue = this.foodInputValue
        if (foodInputValue && this.foodtags.indexOf(foodInputValue) > -1) {
          this.$alert('已经有这个食品标签了！', '添加失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              // this.$router.push('/')
            }
          })
        } else if (foodInputValue && this.foodtags.indexOf(foodInputValue) < 0) {
          const response = await changetags.foodAdd({
            prefer: foodInputValue
          },
          {
            headers: {'Authorization': this.$store.state.token}
          })
          this.foodtags.push(foodInputValue)
          console.log(response)
        }
        this.foodInputVisible = false
        this.foodInputValue = ''
      } catch (error) {
        console.log(error)
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
          this.$alert('添加食品喜好标签失败！', '网络错误', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              // this.$router.push('/')
            }
          })
        } else {
          this.error = error.response.data.error
        }
      }
    },
    async sportHandleClose (tag) {
      try {
        const response = await changetags.sportDelete({
          prefer: tag
        },
        {
          headers: {'Authorization': this.$store.state.token}
        })
        this.sporttags.splice(this.sporttags.indexOf(tag), 1)
        console.log(response)
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
          this.$alert('删除服务喜好标签失败！', '网络错误', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              // this.$router.push('/')
            }
          })
        } else {
          this.error = error.response.data.error
        }
      }
    },
    sportShowInput () {
      this.sportInputVisible = true
      this.$nextTick(_ => {
        this.$refs.saveTagInput.$refs.input.focus()
      })
    },
    async sportHandleInputConfirm () {
      try {
        let sportInputValue = this.sportInputValue
        if (sportInputValue && this.sporttags.indexOf(sportInputValue) > -1) {
          this.$alert('已经有这个健身标签了！', '添加失败', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              // this.$router.push('/')
            }
          })
        } else if (sportInputValue && this.sporttags.indexOf(sportInputValue) < 0) {
          const response = await changetags.sportAdd({
            prefer: sportInputValue
          },
          {
            headers: {'Authorization': this.$store.state.token}
          })
          this.sporttags.push(sportInputValue)
          console.log(response)
        }
        this.sportInputVisible = false
        this.sportInputValue = ''
      } catch (error) {
        if (typeof (error.response) === 'undefined' || typeof (error.response.data) === 'undefined') {
          this.error = 'Network Error'
          this.$alert('添加服务喜好标签失败！', '网络错误', {
            confirmButtonText: '确定',
            callback: action => {
              this.$message({
                type: 'info',
                message: `action: ${action}`
              })
              // this.$router.push('/')
            }
          })
        } else {
          this.error = error.response.data.error
        }
      }
    }
  }
}
</script>

<style scoped>
.el-tag + .el-tag {
margin-left: 10px;
}
.button-new-tag {
margin-left: 10px;
height: 32px;
line-height: 30px;
padding-top: 0;
padding-bottom: 0;
}
.input-new-tag {
width: 90px;
margin-left: 10px;
vertical-align: bottom;
}
.el-header {
    background-color: #333;
}
.el-main {
    padding-top: 0;
}
</style>
